
/*
** bot.c -- a stream "client" robot for punter
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
/* #include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h> */
#include "quaternion.h"
#include "player.h"
#include "gameeng.h"

void usage(char *pname) {
        fprintf(stderr,"usage: %s hostname [port]\n", pname);
}



int main(int argc, char *argv[])
{
	game_packet_t gp;
	game_t thisgame;
	player_t *ego;
	float theta, radius, tick, startrad, xpos, ypos, zpos,
		xcenter, ycenter, zcenter;
	char *servername;
	char pname[] = "Zman the bot, yo!   ";
	int i, skippie, update_counter;

	if (argc > 3) {
		usage(argv[0]);
		exit(1);
	}

	printf("argc: %d\n", argc);
	if (argc > 2) {
		servername = (char *) malloc(sizeof(char) * strlen(argv[2]));
		strcpy(servername, argv[1]);	
	} else {
		servername = (char *) malloc(sizeof(char) * 20);
		strcpy(servername, "localhost");
	}

	
	game_clear(&thisgame);

	if ( game_connect(&thisgame, servername, 0) == -1) {
		fprintf(stderr, "Failed to conenct to server %s, port %d\n", servername, 0);
		exit(1);
	}


	if (argc > 1)
		sprintf(pname, "I'm bot %s!", argv[1]);
	else
		sprintf(pname, "I'm bot anon!");

	game_join(&thisgame, pname);

	ego = &thisgame.players[thisgame.first_person_index];

	printf("I joined, and I'm at: %3.2f %3.2f %3.2f\n",
		ego->location[0], ego->location[1], ego->location[2]);

	theta = 0.0;
	radius = 10.0;
	xcenter = ycenter = zcenter = 0.0;
	startrad = 3000.0;
	tick = 0.1;
	skippie = 0;
	update_counter = 0;
	while (startrad > 0.0) {
		/* 
		xpos = radius * cos(theta) + xcenter;
		ypos = radius * cos(theta) + ycenter;
		zpos = zcenter;
		gp.packet_type = 99;
		gp.data.floatdata[0] = xpos;
		gp.data.floatdata[1] = ypos;
		gp.data.floatdata[2] = zpos;
		*/
		/* oooh... strafe.  that's forward, sideways, mouse delta */
		/*ego->key_actions = PLAYER_KEY_FORWARD | PLAYER_KEY_STRAFE_LEFT; */
		ego->key_actions = PLAYER_KEY_FORWARD | PLAYER_KEY_STRAFE_LEFT; 
		ego->key_actions = PLAYER_KEY_BACKWARD | PLAYER_KEY_STRAFE_LEFT;
		ego->mouse_buttons = 0 | PLAYER_MOUSE_BUTTON_0; 
		ego->mouse_delta[0] = 4;
		ego->mouse_delta[1] = 1 - 2 * (int) ( startrad - (int) startrad  + 0.51);

		startrad -= tick;
		theta = startrad;

		game_submit(&thisgame, ego);
		/* game_send(&thisgame, &gp); */
		game_update(&thisgame);
		update_counter++;
		if (skippie == 0) { skippie = 1000;
		printf("UPDATE COUNTER %d\n", update_counter);
		for ( i = 0; i < GAME_MAX_CLIENTS ; i++) {
			if (thisgame.players[i].status != PLAYER_STATUS_INACTIVE) {
				printf("Status of player %d is %d,  not %d\n", 
				thisgame.players[i].player_id,
			thisgame.players[i].status , PLAYER_STATUS_INACTIVE);
				
				player_print(&thisgame.players[i]);
			}
		}
		}
		skippie--;

		usleep(10000);
	}
	/* game_quit(&thisgame); */
	game_disconnect(&thisgame);
	exit(0);
}
