/* This code was created by Jeff Molofee '99 (Ported to Linux/GLX by
 * Patrick Schubert 2000 with the help from lesson 1 basecode for Linux/GLX
 * by Mihael Vrbanec).
 *
 * Cleaned up and Hopefully easier to read version by Jason Schultz (2004)
 *
 * @File:			glx_base.h
 *
 * @Description: 	Main Header File for OpenGL/GLX Base code
 */
 
#ifndef _GLX_BASE_H_
#define _GLX_BASE_H_
 
/* Standard OpenGL/GLX header files */
#include <GL/glx.h>
#include <GL/gl.h>
/* Headers needed for keys used in the program */
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
/* Standard C header files */
#include <stdio.h>
#include <stdlib.h>
#include <math.h> 
#include <time.h>
#include "player.h"
#include "gameeng.h"
 
/* Function Definitions */
 
/* defined in glx_base.c : */
void createGLWindow(const char* title, int width, int height, int bpp, BOOL fsflag); /* called in main() */
void mainLoop(game_t *G); /* called in main(). handles xevents, calls drawGLScene(), swapBuffers() */
void killGLWindow(void); /* called in main(), mainLoop() to toggle fullscreen w/ F1 */
void resizeGLScene(void); /* called in createGLWindow(), mainLoop() */
void swapBuffers(void);   /* called in mainLoop(). */
Cursor createnullcursor( Display *display, Window root); /* called in createGLWindow */

/* defined elsewhere e.g. main.c */
void initKeys(char autorepeat); /* never defined */
void updateGLScene(void); /* never called, should be called in mainLoop() */
BOOL initGLScene(void); /* called in main() */
void cleanGLScene(void); /* called in main() */
void drawGLScene(void); /* called by mainLoop() */
void keyboard(char *); /*new keyboard routine */
void reshape(int x, int y); /*old glut reshape routine */
void motion(int x, int y);
void mouse(int, int, int, int);
void genKeyString(XKeyEvent *kbd_event, char *keylist); /* create keybd list */












/* program flow:
main()
	createGLWindow() 		#creates visual, colormap, event masks, grabs pointer, etc.
		resizeGLScene()		#frustrum, aspect ratio
	initGLScene()			#glEnable,etc. clean w/cleanGLscene()
	mainLoop() 			#main loop until exit
		xevents:
			killGLWindow()/createGLWindow()
			resizeGLScene()
			killGLWindow()
		drawGLScene()		#eqiv. to glut display func.
		swapBuffers()		#glXSwapBuffers(GLWin.dpy, GLWin.win);
	cleanGLscene()
	killGLWindow()
*/
 
#endif /* End of _GLX_BASE_H_ */
